package xyz.pixelatedw.finalbeta;

import net.minecraft.entity.LivingEntity;
import net.minecraft.util.maths.MathsHelper;

public enum Direction {
	SOUTH,
	WEST,
	NORTH,
	EAST,
	;
	
	private String displayName;
	
	private Direction() {
		String name = this.name();
		this.displayName = Character.toUpperCase(name.charAt(0)) + name.substring(1).toLowerCase();
	}
	
	public static Direction fromEntity(LivingEntity entity) {
		int dir = MathsHelper.floor(entity.yaw / 90.0D + 0.5D) & 3;
		return values()[Math.abs(dir) % values().length];
	}

	@Override
	public String toString() {
		return this.displayName;
	}
}
