package xyz.pixelatedw.finalbeta;

import org.lwjgl.opengl.GL11;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.widgets.Button;

public class ModSlider extends Button {
	public float value = 1.0F;
	public boolean dragged = false;
	public final String defaultText;
	private final IChanceValue changeEvent;

	public ModSlider(int id, int x, int y, String label, float initialValue, IChanceValue changeEvent) {
		super(id, x, y, 150, 20, label);
		this.value = initialValue;
		this.defaultText = label;
		this.changeEvent = changeEvent;
		this.text = this.defaultText + "" + String.format("%.2f", this.value);
		if (this.id == 301) {
			this.text = this.getCloudHeightString();
		}
	}

	@Override
	protected int getYImage(boolean flag) {
		return 0;
	}

	@Override
	protected void postRender(Minecraft minecraft, int i, int j) {
		if (this.visible) {
			if (this.dragged) {
				this.value = (float) (i - (this.x + 4)) / (float) (this.width - 8);
				if (this.value < 0.0F) {
					this.value = 0.0F;
				}

				if (this.value > 1.0F) {
					this.value = 1.0F;
				}
				
				this.text = this.defaultText + "" + String.format("%.2f", this.value);

				this.changeEvent.changeValue(this.value);

				if (this.id == 301) {
					this.text = this.getCloudHeightString();
				}
			}

			GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
			this.blit(this.x + (int) (this.value * (this.width - 8)), this.y, 0, 66, 4, 20);
			this.blit(this.x + (int) (this.value * (this.width - 8)) + 4, this.y, 196, 66, 4, 20);
		}
	}

	@Override
	public boolean isMouseOver(Minecraft minecraft, int i, int j) {
		if (super.isMouseOver(minecraft, i, j)) {
			this.value = (float) (i - (this.x + 4)) / (float) (this.width - 8);
			if (this.value < 0.0F) {
				this.value = 0.0F;
			}

			if (this.value > 1.0F) {
				this.value = 1.0F;
			}

			this.changeEvent.changeValue(this.value);
			this.text = this.defaultText + "" + String.format("%.2f", this.value);
			this.dragged = true;
			return true;
		} else {
			return false;
		}
	}

	private String getCloudHeightString() {
		return this.defaultText + "" + String.format("%.2f", 108.0f + (108.0f * 2.0f * this.value));
	}
	
	@Override
	public void mouseReleased(int i, int j) {
		this.dragged = false;
	}
	
	public interface IChanceValue {
		void changeValue(float value);
	}
}
