package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.At.Shift;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

import net.minecraft.entity.player.Player;
import net.minecraft.item.ItemInstance;
import net.minecraft.item.ItemType;
import net.minecraft.item.tool.BowItem;
import net.minecraft.level.Level;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(BowItem.class)
public class BowItemMixin {
	@Inject(method = "<init>(I)V", at = @At("TAIL"))
	public void init(int i, CallbackInfo ci) {
		ItemType item = ((ItemType) (Object) this);
		
		if (ModConfig.FIX_BOW_MODEL.get()) {
			item.method_466();
		}
		
		if (ModConfig.FIX_BOW_DURABILITY.get()) {
			((ItemTypeAccessor) item).setDurability(385);
		}
	}
	
	@Inject(method = "use", at = @At(value = "INVOKE", target = "Lnet/minecraft/level/Level;spawnEntity(Lnet/minecraft/entity/Entity;)Z", shift = Shift.AFTER))
	public void use(ItemInstance stack, Level level, Player player, CallbackInfoReturnable<ItemInstance> cir) {
		if (ModConfig.FIX_BOW_DURABILITY.get()) {
			stack.applyDamage(1, player);
		}
	}
}
