package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.ModifyVariable;

import net.minecraft.entity.Entity;
import net.minecraft.entity.Minecart;
import net.minecraft.tile.Tile;
import net.minecraft.util.maths.MathsHelper;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(Entity.class)
public class EntityMixin {

	@ModifyVariable(method = "move(DDD)V", at = @At("HEAD"), ordinal = 0)
	private double boostXSpeed(double xSpeed) {
		Entity entity = ((Entity) (Object) this);
		if (entity instanceof Minecart && !entity.field_1642) {
			Minecart minecart = (Minecart) entity;
			boostSpeed(minecart, xSpeed);
		}
		return xSpeed;
	}
	
	@ModifyVariable(method = "move(DDD)V", at = @At("HEAD"), ordinal = 2)
	private double boostZSpeed(double zSpeed) {
		Entity entity = ((Entity) (Object) this);
		if (entity instanceof Minecart && !entity.field_1642) {
			Minecart minecart = (Minecart) entity;
			boostSpeed(minecart, zSpeed);
		}
		return zSpeed;
	}
	
	private double boostSpeed(Minecart minecart, double original) {
		int x = MathsHelper.floor(minecart.x);
		int y = MathsHelper.floor(minecart.y);
		int z = MathsHelper.floor(minecart.z);
		int tileId = minecart.level.getTileId(x, y, z);
		if (tileId == Tile.GOLDEN_RAIL.id) {
			double boostedSpeed = Math.min(original * ModConfig.MINECART_POWERED_BOOST.get(), ModConfig.MINECART_MAX_SPEED.get());
			return boostedSpeed;
		}
		return original;
	}
}
